package com.usky.backend.client;

import com.usky.backend.domain.StatusVO;
import com.usky.backend.domain.request.LastQueryVo;
import com.usky.backend.domain.response.LastResultVo;
import com.usky.common.core.bean.ApiResult;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(contextId = "dataQueryClient", value = "usky-backend")
public interface DataQueryClient {

    @PostMapping("/last")
    ApiResult<List<LastResultVo>> last(@RequestBody LastQueryVo lastQueryVo);

    @GetMapping("/status")
    public ApiResult<List<StatusVO>> status();
}
