package com.usky.backend.controller.api;
import com.usky.backend.client.DataQueryClient;
import com.usky.backend.domain.StatusVO;
import com.usky.backend.domain.request.LastQueryVo;
import com.usky.backend.domain.response.LastResultVo;
import com.usky.backend.service.DataQueryService;
import com.usky.common.core.bean.ApiResult;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  数据统一查询 前端控制器
 * </p>
 *
 */
@RestController
@Api(tags = "数据统一查询RPC")
@RequestMapping("/dataQueryApi")
public class DataQueryApi implements DataQueryClient {

    @Autowired
    private DataQueryService dataQueryService;

    @Override
    public ApiResult<List<LastResultVo>> last(LastQueryVo lastQueryVo) {
        List<LastResultVo> last = dataQueryService.last(lastQueryVo);
        return ApiResult.success(last);
    }

    @Override
    public ApiResult<List<StatusVO>> status(){
        List<StatusVO> list = dataQueryService.status();
        return ApiResult.success(list);
    }

}