package com.usky.iot.domain;

import java.time.LocalDateTime;
import java.io.Serializable;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 设施类型
 * </p>
 *
 * @author han
 * @since 2023-06-06
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class BaseFacilityType implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    private Integer id;

    /**
     * 类型编码
     */
    private String typeCode;

    /**
     * 类型简称
     */
    private String typeAbbrevia;

    /**
     * 类型名称
     */
    private String typeName;

    /**
     * 类型所属领域
     */
    private String typeDomain;

    /**
     * 类型图片路径
     */
    private String typeImg;

    /**
     * 类型_表现形式
     */
    private Integer typeGuise;

    /**
     * 数据字段
     */
    private String dataField;

    /**
     * 描述
     */
    private String typeDesc;

    /**
     * 创建人
     */
    private String createdBy;

    /**
     * 创建时间
     */
    private LocalDateTime createdTime;

    /**
     * 更新人
     */
    private String updatedBy;

    /**
     * 更新时间
     */
    private LocalDateTime updatedTime;

    /**
     * 租户号
     */
    private Integer tenantId;


}
