package com.usky.iot.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 产品属性表
 * </p>
 *
 * @author ya
 * @since 2022-10-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
public class DmpProductAttribute implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 主键id
     */
    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 产品ID
     */
    private Integer productId;

    /**
     * 属性名称
     */
    private String attributeName;

    /**
     * 属性标识
     */
    private String attributeCode;

    /**
     * 对应端口/属性ID
     */
    private Integer attributePort;

    /**
     * 属性类型;1：必选，2：可选
     */
    private Integer attributeType;

    /**
     * 数据类型
     */
    private Integer dataType;

    /**
     * 绑定状态;1：已绑定，2：未绑定
     */
    private Integer bindStatus;

    /**
     * 长度
     */
    private Integer attributeLength;

    /**
     * 单位
     */
    private Integer attributeUnit;

    /**
     * 最大值
     */
    private BigDecimal maximum;

    /**
     * 最小值
     */
    private BigDecimal minimum;

    /**
     * 时间格式
     */
    private String timeFormat;

    /**
     * 布尔值false
     */
    private String boolFalse;

    /**
     * 布尔值true
     */
    private String boolTrue;

    /**
     * 删除标识;0：未删除，1：已删除
     */
    private Integer deleteFlag;

    /**
     * 描述
     */
    private String attributeDescribe;

    /**
     * 创建人
     */
    private String createdBy;

    /**
     * 创建时间
     */
    private Date createdTime;

    /**
     * 更新人
     */
    private String updatedBy;

    /**
     * 更新时间
     */
    private Date updatedTime;

    /**
     * 租户号
     */
    private Integer tenantId;

}
